﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CustomFixedHeader
{
    public partial class Form1 : Form
    {
        DataTable dt = new DataTable();
        public Form1()
        {
            InitializeComponent();
            dt.Columns.Add("ID");
            dt.Columns.Add("Name");
            dt.Columns.Add("Married", typeof(bool));

            dt.Rows.Add(1, "A", true);
            dt.Rows.Add(2, "B", false);
            dt.Rows.Add(3, "C", true);
            dt.Rows.Add(4, "D", false);
            dt.Rows.Add(5, "E", false);
            dt.Rows.Add(6, "F", true);
            dt.Rows.Add(7, "G", true);
            dt.Rows.Add(8, "H", false);
        }
        

        private void Form1_Load(object sender, EventArgs e)
        {            
            c1FlexGrid1.DataSource = dt;
            c1FlexGrid1.SetCellCheck(0, 3, C1.Win.C1FlexGrid.CheckEnum.Checked);
            c1FlexGrid1.CellChecked += c1FlexGrid1_CellChecked;
            c1FlexGrid1.AllowSorting = C1.Win.C1FlexGrid.AllowSortingEnum.None;
        }

        void c1FlexGrid1_CellChecked(object sender, C1.Win.C1FlexGrid.RowColEventArgs e)
        {
            if (e.Row == 0 && e.Col == 3)
            {
                ChangeState(c1FlexGrid1.GetCellCheck(e.Row, e.Col));
            }
            else
            {
                if (c1FlexGrid1.GetCellCheck(e.Row, e.Col) == C1.Win.C1FlexGrid.CheckEnum.Unchecked)
                    c1FlexGrid1.SetCellCheck(0, 3, C1.Win.C1FlexGrid.CheckEnum.Unchecked);
            }
        }

        void ChangeState(C1.Win.C1FlexGrid.CheckEnum state)
        {
            for (int row = c1FlexGrid1.Rows.Fixed; row < c1FlexGrid1.Rows.Count; row++)
            {
                c1FlexGrid1.SetCellCheck(row, 3, state);
            }
        }
    }
}
